using System.ComponentModel;
using System.Web.UI;
using AjaxControlToolkit;

[assembly: WebResource("jQueryNET.Form.FieldBase.js", "text/javascript")]

namespace jQueryNET
{
	[ClientScriptResource("jQueryNET.Controls.FieldBase", "jQueryNET.Form.FieldBase.js")]
	public class FieldBase : ScriptControlBase
	{
		#region Public constructors

		/// <summary>
		/// Initializes a new ScriptControl
		/// </summary>
		public FieldBase(HtmlTextWriterTag tag)
			: base(tag)
		{
		}

		/// <summary>
		/// Initializes a new ScriptControl
		/// </summary>
		protected FieldBase()
		{
		}

		/// <summary>
		/// Initializes a new ScriptControl
		/// </summary>
		/// <param name="tag"></param>
		protected FieldBase(string tag)
			: base(tag)
		{
		}

		/// <summary>
		/// Initializes a new ScriptControl
		/// </summary>
		/// <param name="enableClientState"></param>
		protected FieldBase(bool enableClientState)
			: base(enableClientState)
		{
		}

		/// <summary>
		/// Initializes a new ScriptControl
		/// </summary>
		/// <param name="enableClientState"></param>
		/// <param name="tag"></param>
		protected FieldBase(bool enableClientState, HtmlTextWriterTag tag)
			: base(enableClientState, tag)
		{
		}

		/// <summary>
		/// Initializes a new ScriptControl
		/// </summary>
		/// <param name="enableClientState"></param>
		/// <param name="tag"></param>
		protected FieldBase(bool enableClientState, string tag)
			: base(enableClientState, tag)
		{
		}

		#endregion

		#region Public properties

		/// <summary>
		/// Allow blank field
		/// </summary>
		[Description("Allow blank field")]
		[Category("Behavior")]
		[ExtenderControlProperty]
		[ClientPropertyName("allowBlank")]
		public bool AllowBlank { get; set; }

		#endregion
	}
}