using System.Web.UI;
using AjaxControlToolkit;
using System.Drawing;
using System.ComponentModel;
using System;

[assembly: WebResource("jQueryNET.Grid.Grid.css", "text/css", PerformSubstitution = true)]
[assembly: WebResource("jQueryNET.Grid.Grid.js", "application/x-javascript", PerformSubstitution = true)]

[assembly: WebResource("jQueryNET.Grid.Images.grid_hrow.gif", "image/gif")]
[assembly: WebResource("jQueryNET.Grid.Images.grid3_hrow_over.gif", "image/gif")]
[assembly: WebResource("jQueryNET.Grid.Images.sort_asc.gif", "image/gif")]
[assembly: WebResource("jQueryNET.Grid.Images.sort_desc.gif", "image/gif")]
[assembly: WebResource("jQueryNET.Grid.Images.grid3_hd_btn.gif", "image/gif")]
[assembly: WebResource("jQueryNET.Grid.Images.row_over.gif", "image/gif")]

[assembly: WebResource("jQueryNET.Grid.Images.page_first.gif", "image/gif")]
[assembly: WebResource("jQueryNET.Grid.Images.page_first_disabled.gif", "image/gif")]
[assembly: WebResource("jQueryNET.Grid.Images.page_last.gif", "image/gif")]
[assembly: WebResource("jQueryNET.Grid.Images.page_last_disabled.gif", "image/gif")]
[assembly: WebResource("jQueryNET.Grid.Images.page_next.gif", "image/gif")]
[assembly: WebResource("jQueryNET.Grid.Images.page_next_disabled.gif", "image/gif")]
[assembly: WebResource("jQueryNET.Grid.Images.page_prev.gif", "image/gif")]
[assembly: WebResource("jQueryNET.Grid.Images.page_prev_disabled.gif", "image/gif")]
[assembly: WebResource("jQueryNET.Grid.Images.refresh.gif", "image/gif")]
namespace jQueryNET
{
	[RequiredScript(typeof(ScriptResources), 0)]
	[RequiredScript(typeof(Common), 1)]
	[RequiredScript(typeof(JQueryScript), 2)]
	[RequiredScript(typeof(ToolBar), 3)]
	[ClientCssResource("jQueryNET.Common.Common.css")]
	[ClientCssResource("jQueryNET.Grid.Grid.css")]
	[ClientScriptResource("jQueryNET.Controls.Grid", "jQueryNET.Grid.Grid.js")]
	[ToolboxBitmap(typeof(Grid), "Grid.Grid.ico")]
	public class Grid : DataControlBase
	{
		#region Public constructors

		/// <summary>
		/// 
		/// </summary>
		public Grid() : base(true, HtmlTextWriterTag.Div)
		{
			PageIndex = 1;
		}

		#endregion

		#region Public properties

		/// <summary>
		///    
		/// </summary>
		//[DefaultValue(10)]
		[Description("Row count on page")]
		[Category("Behavior")]
		[ExtenderControlProperty]
		[ClientPropertyName("rowInPage")]
		public int RowInPage
		{
			get
			{
				object value = ViewState["RowInPage"];
				if (value != null)
					return Convert.ToInt32(value);
				return 0;
			}
			set { ViewState["RowInPage"] = value; }
		}

		[Description("Row count on page")]
		[Category("Behavior")]
		[ExtenderControlProperty(true, true)]
		[ClientPropertyName("header")]
		public HeaderSection Header { get; set; }

		[Description("Current page index")]
		[Category("Behavior")]
		[ExtenderControlProperty]
		[ClientPropertyName("pageIndex")]
		public int PageIndex { get; set; }

		[Description("Data source")]
		[Category("Data")]
		public object DataSource
		{
			get { return m_dataSource; }
			set
			{
//				if (((value != null) && !(value is IListSource)) && !(value is IEnumerable))
//					throw new ArgumentException(Strings.InvalidDataSourceType);

				m_dataSource = value;
			}
		}

		[DefaultValue("")]
		[Category("Behavior")]
		[ExtenderControlEvent]
		[ClientPropertyName("rowClick")]
		public string OnRowClick
		{
			get { return (string)(ViewState["OnRowClick"] ?? string.Empty); }
			set { ViewState["OnRowClick"] = value; }
		}

		[DefaultValue("")]
		[Category("Behavior")]
		[ExtenderControlEvent]
		[ClientPropertyName("rowDoubleClick")]
		public string OnRowDoubleClick
		{
			get { return (string)(ViewState["OnRowDoubleClick"] ?? string.Empty); }
			set { ViewState["OnRowDoubleClick"] = value; }
		}

		[DefaultValue("")]
		[Category("Behavior")]
		[ExtenderControlEvent]
		[ClientPropertyName("contextMenu")]
		public string OnContextMenu
		{
			get { return (string)(ViewState["OnContextMenu"] ?? string.Empty); }
			set { ViewState["OnContextMenu"] = value; }
		}

		#endregion

		#region Private fields

		/// <summary>
		/// 
		/// </summary>
		private object m_dataSource;

		#endregion
		
	}
}